
local function get_pattern (pattern_ix)
  local pattern_ix = renoise.song().selected_pattern_index
  local patterns = renoise.song().patterns
  return patterns[pattern_ix] , pattern_ix
end

local function cur_pattern ()
  local pattern_ix = renoise.song().selected_pattern_index
  return get_pattern (pattern_ix)
end


local function nudge(n)
  local song =  renoise.song()
  local n_col = song.selected_note_column_index
  local t_pos = song.transport.edit_pos
  local c_pos = t_pos.line

  local tr  = song.selected_track_index
  local pat = cur_pattern()

  local pat_len = song.selected_pattern.number_of_lines

  local note = pat.tracks[tr].lines[c_pos].note_columns[n_col].note_value

  if n < 0 and c_pos > 1 or n > 0 and c_pos < pat_len then
     local note2 = pat.tracks[tr].lines[c_pos+n].note_columns[n_col].note_value

	 pat.tracks[tr].lines[c_pos].note_columns[n_col].note_value = note2
	 pat.tracks[tr].lines[c_pos+n].note_columns[n_col].note_value = note
  end
end


local function nudge_up()
 nudge (-1)
end

local function nudge_dw()
 nudge (1)
end


---------- Menu -------------------------------------------

renoise.tool():add_menu_entry {
  name = "Pattern Editor:NudgeC Up",
  invoke = nudge_up
}

renoise.tool():add_menu_entry {
  name = "Pattern Editor:NudgeC Down",
  invoke = nudge_dw
}

------- keys --------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:NudgeC Up",
  invoke = nudge_up
}

renoise.tool():add_keybinding {
  name = "Global:Tools:NudgeC Down",
  invoke = nudge_dw
}
